import java.awt.Color;
import java.awt.event.KeyEvent;
import java.awt.geom.*;

import java.awt.*;
import java.io.File;
import java.util.*;

import javax.swing.JFileChooser;

import edu.umd.cs.piccolo.*;
import edu.umd.cs.piccolo.event.*;
import edu.umd.cs.piccolo.nodes.*;
import edu.umd.cs.piccolo.util.*;
import edu.umd.cs.piccolox.*;

public class HelloWorld extends PFrame {
	
	private int centerX = 300;
	private int centerY = 300;
	private int radius = 50;
	private int width = 50;
	private int viewType = 0;
	
	private JFileChooser fc;
	private String rootPath;
	private Diagram diagram;
	private FileStructure fileStructure;
	
	private void getFiles() {
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			this.rootPath = fc.getSelectedFile().getPath();
			System.out.println(rootPath);
		}

		//FileStructure tmpStructure = new FileStructure("C:\\Dokumente und Einstellungen\\Administrator\\workspace\\InfoVis");
		if (this.rootPath != null) {
			this.fileStructure = new FileStructure(rootPath);
//			ArrayList<FileObject> fileObjects = tmpStructure.getFileObjects();
//			ArrayList<FileStructure> folders = tmpStructure.getFileStructure();
		//System.out.println("ROOT" + tmpStructure.getDirectorySize());
		//System.out.println("FILES");
		//double percent = 0.0;
		//for (int i = 0; i < fileObjects.size(); i++) {
			//percent = percent + fileObjects.get(i).getFilePercentage();
			//System.out.println(fileObjects.get(i).getFileName() + " " + fileObjects.get(i).getFileSize() + " " + fileObjects.get(i).getFilePercentage() + "%");
		//}
		//System.out.println("FOLDERS");
		//for (int i = 0; i < folders.size(); i++) {
			//percent = percent + folders.get(i).getDirectoryPercentage();
			//System.out.println(folders.get(i).getDirectoryName() + " " + folders.get(i).getDirectorySize() + " " + folders.get(i).getDirectoryPercentage()+ "%");
		//}
		//System.out.println("PERCENT SUM: " + percent + "%");	
		//System.out.println("Directory Percentage: " + tmpStructure.getDirectoryPercentage());
		
		
		
//		Diagram diagram = new Diagram(tmpStructure, 150, getCanvas().getLayer());
//			Segment tmpSegment = new Segment(500, 0, 360, null, rootPath, Color.white, null, null, 1);
			if (this.diagram != null) {
				getCanvas().getLayer().removeChild(this.diagram.getDiagramNode());
			}
			this.diagram = new Diagram(this.fileStructure, 150, getCanvas().getLayer(), 1);
			this.diagram.draw(getCanvas().getLayer());
		
		}
		
		
	}
	
	private void setViewType(int i) {
		getCanvas().getLayer().removeChild(this.diagram.getDiagramNode());
		if(i == 1 || i == 2) {
			this.diagram = new Diagram(this.fileStructure, 150, getCanvas().getLayer(), i);
			this.diagram.draw(getCanvas().getLayer());
		}
		if (i == 3) {
			Segment tmpSegment = new Segment(500, 0, 360, null, this.rootPath, Color.white, null, 1);
			this.diagram = new Diagram(this.fileStructure, 150, getCanvas().getLayer(), tmpSegment, i);
			this.diagram.draw(getCanvas().getLayer());
		}
	}


	
	public void initialize() {
		fc = new JFileChooser("C:\\");
		//Segment s1 = new Segment(50, 0, 360, null);
		//Segment s2 = new Segment(50, 0, 180, s1);
		//Segment s3 = new Segment(50, 0, 90, s2);
		//Segment s4 = new Segment(50, 90, 180, s2);
		//Arc2D testArc2 = new Arc2D.Double(x, y, radius, radius, 0, 90, Arc2D.PIE);
		//Arc2D testArc = new Arc2D.Double(x - radius/2, y - radius/2, radius+width, radius+width, 0, 360, Arc2D.PIE);
		//Arc2D testArc3 = new Arc2D.Double(x + radius/2, y + radius/2, radius-49, radius-49, 0, 90, Arc2D.PIE);
		//Ellipse2D e = new Ellipse2D.Float(40, 40, 120, 120);
		//Ellipse2D e2 = new Ellipse2D.Float(40, 40, 100, 100);
		//Area myArea = new Area(testArc2);
		//Area myArea2 = new Area(testArc3);
		//myArea.subtract(myArea2);
		//PPath arc = new PPath(myArea);
		
		
		

		PNode node1 = PPath.createRectangle(5, 5, 120, 19);
		node1.setPaint(Color.gray);
		PText selection = new PText("Select a Folder ...");
		selection.setBounds(8, 8, 115 ,15);
		node1.addChild(selection);
		getCanvas().getLayer().addChild(node1);
		node1.addInputEventListener(new PBasicInputEventHandler() {
			public void mousePressed(PInputEvent event) {
				event.getPickedNode().setPaint(Color.ORANGE);
				event.getInputManager().setKeyboardFocus(event.getPath());
				event.setHandled(true);
			}
			public void mouseDragged(PInputEvent event) {
				PNode aNode = event.getPickedNode();
				PDimension delta = event.getDeltaRelativeTo(aNode);
				aNode.translate(delta.width, delta.height);
				event.setHandled(true);
			}
			public void mouseReleased(PInputEvent event) {
				event.getPickedNode().setPaint(Color.gray);
				event.setHandled(true);
				getFiles();
			}
			public void keyPressed(PInputEvent event) {
				PNode node = event.getPickedNode();
				switch (event.getKeyCode()) {
					case KeyEvent.VK_UP:
						node.translate(0, -10f);
						break;
					case KeyEvent.VK_DOWN:
						node.translate(0, 10f);
						break;
					case KeyEvent.VK_LEFT:
						node.translate(-10f, 0);
						break;
					case KeyEvent.VK_RIGHT:
						node.translate(10f, 0);
						break;
				}
			}
		});
		
		PNode node2 = PPath.createRectangle(5, 29, 120, 19);
		node2.setPaint(Color.gray);
		PText view1 = new PText("Outer View");
		view1.setBounds(8, 31, 115 ,15);
		node2.addChild(view1);
		getCanvas().getLayer().addChild(node2);
		node2.addInputEventListener(new PBasicInputEventHandler() {
			public void mousePressed(PInputEvent event) {
				event.getPickedNode().setPaint(Color.ORANGE);
				event.getInputManager().setKeyboardFocus(event.getPath());
				event.setHandled(true);
			}
			public void mouseDragged(PInputEvent event) {
				PNode aNode = event.getPickedNode();
				PDimension delta = event.getDeltaRelativeTo(aNode);
				aNode.translate(delta.width, delta.height);
				event.setHandled(true);
			}
			public void mouseReleased(PInputEvent event) {
				event.getPickedNode().setPaint(Color.gray);
				event.setHandled(true);
				setViewType(1);
			}
			public void keyPressed(PInputEvent event) {
				PNode node = event.getPickedNode();
				switch (event.getKeyCode()) {
					case KeyEvent.VK_UP:
						node.translate(0, -10f);
						break;
					case KeyEvent.VK_DOWN:
						node.translate(0, 10f);
						break;
					case KeyEvent.VK_LEFT:
						node.translate(-10f, 0);
						break;
					case KeyEvent.VK_RIGHT:
						node.translate(10f, 0);
						break;
				}
			}
		});
		
		PNode node3 = PPath.createRectangle(5, 53, 120, 19);
		node3.setPaint(Color.gray);
		PText view2 = new PText("Segment View");
		view2.setBounds(8, 54, 115 ,15);
		node3.addChild(view2);
		getCanvas().getLayer().addChild(node3);
		node3.addInputEventListener(new PBasicInputEventHandler() {
			public void mousePressed(PInputEvent event) {
				event.getPickedNode().setPaint(Color.ORANGE);
				event.getInputManager().setKeyboardFocus(event.getPath());
				event.setHandled(true);
			}
			public void mouseDragged(PInputEvent event) {
				PNode aNode = event.getPickedNode();
				PDimension delta = event.getDeltaRelativeTo(aNode);
				aNode.translate(delta.width, delta.height);
				event.setHandled(true);
			}
			public void mouseReleased(PInputEvent event) {
				event.getPickedNode().setPaint(Color.gray);
				event.setHandled(true);
				setViewType(2);
			}
			public void keyPressed(PInputEvent event) {
				PNode node = event.getPickedNode();
				switch (event.getKeyCode()) {
					case KeyEvent.VK_UP:
						node.translate(0, -10f);
						break;
					case KeyEvent.VK_DOWN:
						node.translate(0, 10f);
						break;
					case KeyEvent.VK_LEFT:
						node.translate(-10f, 0);
						break;
					case KeyEvent.VK_RIGHT:
						node.translate(10f, 0);
						break;
				}
			}
		});
		
		PNode node4 = PPath.createRectangle(5, 77, 120, 19);
		node4.setPaint(Color.gray);
		PText view3 = new PText("Inner View");
		view3.setBounds(8, 78, 115 ,15);
		node4.addChild(view3);
		getCanvas().getLayer().addChild(node4);
		node4.addInputEventListener(new PBasicInputEventHandler() {
			public void mousePressed(PInputEvent event) {
				event.getPickedNode().setPaint(Color.ORANGE);
				event.getInputManager().setKeyboardFocus(event.getPath());
				event.setHandled(true);
			}
			public void mouseDragged(PInputEvent event) {
				PNode aNode = event.getPickedNode();
				PDimension delta = event.getDeltaRelativeTo(aNode);
				aNode.translate(delta.width, delta.height);
				event.setHandled(true);
			}
			public void mouseReleased(PInputEvent event) {
				event.getPickedNode().setPaint(Color.gray);
				event.setHandled(true);
				setViewType(3);
			}
			public void keyPressed(PInputEvent event) {
				PNode node = event.getPickedNode();
				switch (event.getKeyCode()) {
					case KeyEvent.VK_UP:
						node.translate(0, -10f);
						break;
					case KeyEvent.VK_DOWN:
						node.translate(0, 10f);
						break;
					case KeyEvent.VK_LEFT:
						node.translate(-10f, 0);
						break;
					case KeyEvent.VK_RIGHT:
						node.translate(10f, 0);
						break;
				}
			}
		});
		//getCanvas().getLayer().addChild(s1.getPPath());
		//getCanvas().getLayer().addChild(s2.getPPath());
		//getCanvas().getLayer().addChild(s3.getPPath());
		//getCanvas().getLayer().addChild(s4.getPPath());
		
	}
	

	public static void main(String[] arguments) {
		new HelloWorld();
	}

}
